package com.gyee.alarm.model.auto;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.time.LocalDateTime;
import java.util.Date;
import java.util.List;

import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 预警报告
 * </p>
 *
 * @author shilin
 * @since 2023-09-05
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class ProEconEarlyReport extends Model {

    private static final long serialVersionUID = 1L;

    /**
     * 编号
     */
    private String id;

    /**
     * 报告名称
     */
    private String reportName;

    /**
     * 场站id
     */
    private String stationId;

    /**
     * 场站名称
     */
    private String stationName;

    /**
     * 所属部件
     */
    private String relatedParts;

    /**
     * 报告日期
     */
    private Date reportDate;

    /**
     * 报告分析起始时间
     */
    private Date statStartDate;

    /**
     * 报告分析结束时间
     */
    private Date statEndDate;

    @TableField(exist = false)
    private List<ProEconEarlyReportWt> proEconEarlyReportWtList;
}
