package com.gyee.alarm.controller;


import cn.hutool.poi.excel.ExcelUtil;
import com.gyee.alarm.model.auto.ProBasicDeviceFaultMode;
import com.gyee.alarm.model.vo.AjaxResult;
import com.gyee.alarm.service.DeviceFaultModeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 设备故障模型 前端控制器
 * </p>
 *
 * @author shilin
 * @since 2023-09-14
 */
@RestController
@RequestMapping("//device/faultmode")
public class ProBasicDeviceFaultModeController {


    @Autowired
    private DeviceFaultModeService deviceFaultModeService;


    @GetMapping(value = "/{deviceId}")
    public List<ProBasicDeviceFaultMode> getDeviceFaultModeByDeviceId(@PathVariable("deviceId")  String deviceId) {
        return deviceFaultModeService.getDeviceFaultModeByDeviceId(deviceId);
    }

    @GetMapping(value = "/{deviceId}/{structurecode}")
    public List<ProBasicDeviceFaultMode> getDeviceFaultModeBySturctureCode(@PathVariable("deviceId")  String deviceId,
                                                                   @PathVariable("structurecode")  String structurecode) {
        return deviceFaultModeService.getDeviceFaultModeByStructureCode(deviceId, structurecode);
    }


    @GetMapping(value = "/single/{code}")
    public ProBasicDeviceFaultMode getDeviceFaultModeByCode(@PathVariable("code")  String code) {
        return deviceFaultModeService.getDeviceFaultModeByCode(code);
    }


    @DeleteMapping(value = "/delete/{id}")
    public boolean deleteDeviceFaultMode(@PathVariable("id") String id) {
        boolean result = deviceFaultModeService.deleteDeviceFaultMode(id);
        return result;
    }

    @PostMapping()
    @ResponseBody
    public AjaxResult saveDeviceFaultMode(@RequestBody ProBasicDeviceFaultMode ds) {


         deviceFaultModeService.saveorUpdateDeviceFaultMode(ds);

        AjaxResult  wrapper = dataCheck(ds);

        return wrapper;
    }

    private AjaxResult  dataCheck(ProBasicDeviceFaultMode ds) {

        AjaxResult  wrapper = null;
        String msg = "";
        boolean result = true;

        if (ds.getCode() == null || ds.getCode().equals("")) {
            msg = "结构编码不能为空";
            result = false;
        } else if (ds.getDeviceid() == null || ds.getDeviceid().equals("")) {
            msg = "设备ID不能为空";
            result = false;
        } else if (ds.getName() == null || ds.getName().equals("")) {
            msg = "名称不能为空";
            result = false;
        }
        if (result) {
            wrapper = AjaxResult.success(msg);
        } else {
            wrapper = AjaxResult.error(msg);
        }
        return wrapper;
    }



    private AjaxResult  dataCheck2(ProBasicDeviceFaultMode ds) {

        AjaxResult  wrapper = null;
        String msg = "";
        boolean result = true;

        if (ds.getCode() == null || ds.getCode().equals("")) {
            msg = "结构编码不能为空";
            result = false;
        }  else if (ds.getName() == null || ds.getName().equals("")) {
            msg = "名称不能为空";
            result = false;
        }
        if (result) {
            wrapper = AjaxResult.success(msg);
        } else {
            wrapper = AjaxResult.error(msg);
        }
        return wrapper;
    }
}
