package com.gyee.alarm.model.auto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.time.LocalDateTime;
import java.util.Date;
import java.util.List;

import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 规则修改记录
 * </p>
 *
 * @author shilin
 * @since 2023-08-15
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class ProEconRuleUpdateEvent extends Model {

    private static final long serialVersionUID = 1L;

    /**
     * 编号
     */
    @TableId(value = "ID",type = IdType.INPUT)
    private String id;

    /**
     * 报警名称
     */
    private String ruleName;

    /**
     * 报警类别
     */
    private String ruleType;

    /**
     * 报警编号
     */
    private String ruleId;

    /**
     * 操作时间
     */
    private Date updateTime;

    /**
     * 操作类别
     */
    private String updateType;

    /**
     * 操作用户编号
     */
    private String updateUser;

    /**
     * 场站编号
     */
    private String stationId;

    /**
     * 型号编号
     */
    private String modelId;

    @TableField(exist = false)
    private List<ProEconRuleUpdateInfo> infoList;

    @TableField(exist = false)
    private String stationName;
}
